"use strict";
var rxjs_1 = require('rxjs');
var MatchMergeTransformer = (function () {
    function MatchMergeTransformer() {
    }
    MatchMergeTransformer.prototype.process = function (observable) {
        return observable.reduce(this.matchMerge.bind(this), []).flatMap(function (merged) {
            return rxjs_1.Observable.from(merged);
        });
    };
    MatchMergeTransformer.prototype.matchMerge = function (merged, o2) {
        for (var i = 0; i < merged.length; i++) {
            if (this.match(merged[i], o2)) {
                var o1 = merged.splice(i, 1)[0];
                o2 = this.merge(o1, o2);
                // Try to merge the merged element with the remaining elements,
                // starting from the current position
                i--;
            }
        }
        merged.push(o2);
        return merged;
    };
    return MatchMergeTransformer;
}());
exports.MatchMergeTransformer = MatchMergeTransformer;
